EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_COLLECTION_VIEW_EVENT_ITEM_REALIZED =
   EFL_EVENT_DESCRIPTION("item,realized");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_COLLECTION_VIEW_EVENT_ITEM_UNREALIZED =
   EFL_EVENT_DESCRIPTION("item,unrealized");

void _efl_ui_collection_view_factory_set(Eo *obj, Efl_Ui_Collection_View_Data *pd, Efl_Ui_Factory *factory);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_collection_view_factory_set, EFL_FUNC_CALL(factory), Efl_Ui_Factory *factory);

Efl_Ui_Factory *_efl_ui_collection_view_factory_get(const Eo *obj, Efl_Ui_Collection_View_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_collection_view_factory_get, Efl_Ui_Factory *, NULL);

void _efl_ui_collection_view_position_manager_set(Eo *obj, Efl_Ui_Collection_View_Data *pd, Efl_Ui_Position_Manager_Entity *position_manager);

static void
_efl_ui_collection_view_position_manager_set_ownership_fallback(Efl_Ui_Position_Manager_Entity *position_manager)
{
   efl_del(position_manager);
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_FALLBACK(efl_ui_collection_view_position_manager_set, _efl_ui_collection_view_position_manager_set_ownership_fallback(position_manager);, EFL_FUNC_CALL(position_manager), Efl_Ui_Position_Manager_Entity *position_manager);

Efl_Ui_Position_Manager_Entity *_efl_ui_collection_view_position_manager_get(const Eo *obj, Efl_Ui_Collection_View_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_collection_view_position_manager_get, Efl_Ui_Position_Manager_Entity *, NULL);

Efl_Object *_efl_ui_collection_view_efl_object_constructor(Eo *obj, Efl_Ui_Collection_View_Data *pd);


void _efl_ui_collection_view_efl_object_invalidate(Eo *obj, Efl_Ui_Collection_View_Data *pd);


void _efl_ui_collection_view_efl_ui_layout_orientable_orientation_set(Eo *obj, Efl_Ui_Collection_View_Data *pd, Efl_Ui_Layout_Orientation dir);


Efl_Ui_Layout_Orientation _efl_ui_collection_view_efl_ui_layout_orientable_orientation_get(const Eo *obj, Efl_Ui_Collection_View_Data *pd);


Eina_Error _efl_ui_collection_view_efl_ui_widget_theme_apply(Eo *obj, Efl_Ui_Collection_View_Data *pd);


void _efl_ui_collection_view_efl_ui_scrollable_match_content_set(Eo *obj, Efl_Ui_Collection_View_Data *pd, Eina_Bool w, Eina_Bool h);


Efl_Ui_Focus_Manager *_efl_ui_collection_view_efl_ui_widget_focus_manager_focus_manager_create(Eo *obj, Efl_Ui_Collection_View_Data *pd, Efl_Ui_Focus_Object *root);


Efl_Ui_Focus_Object *_efl_ui_collection_view_efl_ui_focus_manager_move(Eo *obj, Efl_Ui_Collection_View_Data *pd, Efl_Ui_Focus_Direction direction);


Eina_Bool _efl_ui_collection_view_efl_ui_widget_focus_state_apply(Eo *obj, Efl_Ui_Collection_View_Data *pd, Efl_Ui_Widget_Focus_State current_state, Efl_Ui_Widget_Focus_State *configured_state, Efl_Ui_Widget *redirect);


static Eina_Bool
_efl_ui_collection_view_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_COLLECTION_VIEW_EXTRA_OPS
#define EFL_UI_COLLECTION_VIEW_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_collection_view_factory_set, _efl_ui_collection_view_factory_set),
      EFL_OBJECT_OP_FUNC(efl_ui_collection_view_factory_get, _efl_ui_collection_view_factory_get),
      EFL_OBJECT_OP_FUNC(efl_ui_collection_view_position_manager_set, _efl_ui_collection_view_position_manager_set),
      EFL_OBJECT_OP_FUNC(efl_ui_collection_view_position_manager_get, _efl_ui_collection_view_position_manager_get),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_ui_collection_view_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_invalidate, _efl_ui_collection_view_efl_object_invalidate),
      EFL_OBJECT_OP_FUNC(efl_ui_layout_orientation_set, _efl_ui_collection_view_efl_ui_layout_orientable_orientation_set),
      EFL_OBJECT_OP_FUNC(efl_ui_layout_orientation_get, _efl_ui_collection_view_efl_ui_layout_orientable_orientation_get),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_theme_apply, _efl_ui_collection_view_efl_ui_widget_theme_apply),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_match_content_set, _efl_ui_collection_view_efl_ui_scrollable_match_content_set),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_focus_manager_create, _efl_ui_collection_view_efl_ui_widget_focus_manager_focus_manager_create),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_move, _efl_ui_collection_view_efl_ui_focus_manager_move),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_focus_state_apply, _efl_ui_collection_view_efl_ui_widget_focus_state_apply),
      EFL_UI_COLLECTION_VIEW_EXTRA_OPS
   );
   opsp = &ops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_collection_view_class_desc = {
   EO_VERSION,
   "Efl.Ui.Collection_View",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Ui_Collection_View_Data),
   _efl_ui_collection_view_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_collection_view_class_get, &_efl_ui_collection_view_class_desc, EFL_UI_LAYOUT_BASE_CLASS, EFL_UI_LAYOUT_ORIENTABLE_INTERFACE, EFL_UI_FOCUS_MANAGER_SUB_MIXIN, EFL_UI_WIDGET_FOCUS_MANAGER_MIXIN, EFL_UI_ITEM_CLICKABLE_INTERFACE, EFL_UI_SCROLLABLE_INTERFACE, EFL_UI_SCROLLBAR_INTERFACE, EFL_UI_MULTI_SELECTABLE_INDEX_RANGE_INTERFACE, EFL_UI_SINGLE_SELECTABLE_INTERFACE, NULL);
